// oscwnd.h : header file
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

/////////////////////////////////////////////////////////////////////////////
// COscWnd window

class COscWnd : public CStatic
{
// Construction
public:
	COscWnd();

// Attributes
public:
int	m_leido;
protected:
	int	m_estado;
	BYTE* m_Osc;

	// Device Context Attributes
	CDC* m_pMemDC;
	CDC* m_nueDC;
	CWindowDC* m_pWinDC;

	// Palette Attributes
	RGBQUAD m_rgbPalette[256];
	CPalette m_Palette;
	CPalette* m_pOldPalette;

	// Bitmap Attributes
	CBitmap m_Bitmap;
	CBitmap* m_pOldBitmap;
	BYTE* m_pBits;

// Operations
public:
	enum { red = 1, green = 2, blue = 3 };
	void InitOsc(int nColor);
	CPalette* GetPalette();
	RenderView(int m_bright);
	void Grabar_Archivo();
	void Cargar_Archivo();
	void PaintFlame(CDC* pDC = NULL);
	int GetMaxBurn();
	CSize GetBitmapSize();
	long	ctrl;

protected:
	void CreatePalette(int nColor);
	void CreateBitmap();
	void BurnPoint(BYTE* pRow, BYTE* pNextRow);

public:
	virtual ~COscWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(COscWnd)
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg BOOL OnQueryNewPalette();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
